<?php

require('typewrapper.php');

// Saját osztályunk a teszteléshez
class pair
{
	public $first;
	public $second;
	
	public function __construct($first, $second)
	{
		$this->first = $first;
		$this->second = $second;
	}
}

// Egy osztály, mely örökli a typewrapper-t
class X extends typewrapper
{
	public function __construct()
	{
		$this->className = __CLASS__;
		$this->init();
	}
}

// Egy osztály, mely implicit módon örökli a typewrapper-t
class B extends X
{
	private $x;
	
	public function getName() { return $this->x; }
	public function setName($name) { $this->x = $name; }
	
	public function __construct()
	{
		$this->className = __CLASS__;
		$this->init();
	}
	
	// "Polimorfikus" metódusok
	
	public function Write_Int($i)
	{
		echo "Int: $i";
	}
	
	public function Write_String($s)
	{
		echo "String: \"$s\"";
	}
	
	public function Write_Array($a)
	{
		$first = TRUE;
		echo "Array: (";
		foreach($a as $key => $value)
		{
			if ($first) $first = FALSE;
			else echo ', ';
			echo "[";
			$this->Write($key);
			echo "] => ";
			$this->Write($value);
		}
		echo ")";
	}
	
	public function Write_Pair($p)
	{
		echo "Pair: (";
		$this->Write($p->first);
		echo ", ";
		$this->Write($p->second);
		echo ")";
	}
	
	public function WriteLn($o) { $this->Write($o); echo "\n"; } 
}

header('Content-Type: text/plain; charset=utf-8');

// Tesztelés :P
$b = new B();
$b->WriteLn(4);
$b->WriteLn("Hi!");
$b->WriteLn(array('a', 'b'));
$b->WriteLn(new pair(1, 200));
$b->Name = 'Béla';
$b->WriteLn($b->Name);

?>